
QGIS Application - Bug report #18516

Crash during export of vector file as Mapinfo TAB when 'symbology export' option selected.

2018-03-23 01:24 AM - Matthew Bodnar

Status: Closed

Priority: High

Assignee:

Category: Unknown

Affected QGIS version:3.0.0 Regression?: No

Operating System: WIN 10 1709 Easy fix?: No

Pull Request or Patch supplied:Yes Resolution:

Crashes QGIS or corrupts data:Yes Copied to github as #: 26404

Description

User Feedback

I was trying to 'save as' a .shp polygon vector as a MapInfo TAB file with symbology exported as 'Feature Symbology'... then it crashed. 

It also crashed when exporting symbology as 'Symbol layer symbology'

It DID NOT crash when saving as a TAB file without symbology export selected.

Report Details

Crash ID: 8fa2b8b945ec9edae6d3e80a748de8536d56c77e

Stack Trace

QgsExpression::evaluate :

QgsGraduatedSymbolRenderer::valueForFeature :

QgsGraduatedSymbolRenderer::originalSymbolForFeature :

QgsFeatureRenderer::symbolsForFeature :

QgsVectorFileWriter::addFeatureWithStyle :

QgsVectorFileWriter::writeAsVectorFormat :

QgsVectorFileWriterTask::run :

QgsTask::start :

QThreadPoolPrivate::reset :

QThread::start :

BaseThreadInitThunk :

RtlUserThreadStart :

QGIS Info

QGIS Version: 3.0.0-Girona

QGIS code revision: commit:001c80b0c3

Compiled against Qt: 5.9.2

Running against Qt: 5.9.2

Compiled against GDAL: 2.2.3

Running against GDAL: 2.2.3

System Info

CPU Type: x86_64

Kernel Type: winnt

Kernel Version: 10.0.16299

Associated revisions

Revision 95d2a27c - 2018-03-30 12:01 AM - Nyall Dawson

Split QgsVectorFileWriter writeAsVectorFormat into two methods

to allow correct thread-safe usage
There is now a prepare method, which must be run on the main

thread and which prepopulates feature iterators and clones

renderers, and a separate write method which is safe to

execute on background threads (e.g. tasks)

Fixes #18516

Revision d88ffc6c - 2018-04-02 05:01 AM - Nyall Dawson

Split QgsVectorFileWriter writeAsVectorFormat into two methods

to allow correct thread-safe usage

There is now a prepare method, which must be run on the main

thread and which prepopulates feature iterators and clones

renderers, and a separate write method which is safe to

execute on background threads (e.g. tasks)

Fixes #18516

(cherry-picked from 95d2a27)

History

#1 - 2018-03-23 09:43 PM - Matthew Bodnar

This crash appears to be related to the symbology export, regardless of file type being export. If anything other than 'no symbology' is selected, QGIS 3.0.0

will crash.

#2 - 2018-03-28 12:28 AM - Nyall Dawson

- Status changed from Open to In Progress

#3 - 2018-03-28 12:36 AM - Nyall Dawson

- Pull Request or Patch supplied changed from No to Yes

PR https://github.com/qgis/QGIS/pull/6695

#4 - 2018-03-30 12:01 AM - Nyall Dawson

- % Done changed from 0 to 100

- Status changed from In Progress to Closed

Applied in changeset commit:qgis|95d2a27cbff18caae953ac2132dcb8d3f872cc9a.
